----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:17:26 04/23/2008 
-- Design Name: 
-- Module Name:    BCDcount1 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity BCDcount1 is
	Port ( 	
		clk : in  STD_LOGIC;
		ar : in  STD_LOGIC;
		ce : in  STD_LOGIC;
		q : out  STD_LOGIC_VECTOR (3 downto 0);
		carry : out  STD_LOGIC);
end BCDcount1;

architecture Behavioral of BCDcount1 is

begin

process (clk, ar)
	variable qt : STD_LOGIC_VECTOR (3 downto 0);
	begin
	if  ar = '1' then qt :="0000"; carry <='0';
		elsif rising_edge(clk) then
			if ce = '1' then
				if qt = "1000" then carry <= '1'; qt := qt+1;
				elsif qt = "1001" then qt := "0000"; carry <= '0';
				else carry <= '0'; qt := qt+1;
				end if;
			end if;
		end if;
q <= qt;
end process;

end Behavioral;

